#!/usr/bin/perl
# 
# log converter for JUGEM
# == scripted by SimpleBoxes 2004 =====

{ # 
	use strict;
	use vars qw($gVersion_ %gEnv $sbLog $gBuf $gEncode @gIn %gIn);
	use lib qw(. ../lib ../ext);
	require 'sbtext.pl';
	require 'sbform.pl';
	require Jcode;
	$gEncode = \&Jcode::convert;
	$gEnv{'basic'}{'max_data'} = 2048000;
	$gVersion_ = '0.01';
}
{ # ᥤ󥹥ץ
	&sbform_read();
	if ($gIn{'submit'}) {
		&main($gIn{'uri'},$gIn{'xml'});
	} else {
		&entrance();
	}
}
exit(0);

sub entrance {
	my $cgi = 'xml2mtlog.cgi';
	print 'Content-type: text/html;charset=EUC-JP',"\n\n"; # http head
	print <<"_HTML_";
<?xml version=\"1.0\" encoding=\"EUC-JP\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">
<head>
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<link rel="stylesheet" type="text/css" href="style.css" title="default" media="screen,tv" />
	<title>Ѵץ</title>
</head>
<body>
<h1><a href=\"../index.html\"><img src=\"title.gif\" width=\"700\" height=\"50\" alt=\"sb - Development Laboratory\" title=\"sb - Development Laboratory\" /></a></h1>
<form class=\"single\" action=\"$cgi\" method=\"post\" enctype=\"multipart/form-data\">
<h2>JUGEM Simple XML \&rArr; MovableType Log Text</h2>
<dl>
	<dt><label for=\"uri\" accesskey=\"u\" title=\"JUGEMȤΥɥ쥹ꤷޤ\">uri</label></dt>
	<dd><input type=\"text\" name=\"uri\" id=\"uri\" value=\"http://\" size=\"50\" /></dd>
	<dt><label for=\"xml\" accesskey=\"x\" titel=\"JUGEMΥ(XML)եľܻꤹ뤳Ȥޤ\">xml file</label></dt>
	<dd><input type=\"file\" name=\"xml\" id=\"xml\" value=\"\" size=\"50\" /></dd>
	<dt><label for=\"uri\" accesskey=\"c\" title=\"Ϥʸɤ򤷤Ƥ\">output code</label></dt>
	<dd>
		<select name=\"code\">
			<option value=\"utf8\">Unicode(UTF-8)</option>
			<option value=\"euc\">EUC</option>
			<option value=\"sjis\">Shift JIS</option>
			<option value=\"jis\">JIS</option>
		</select>
	</dd>
	<dt class=\"submit\"><label for=\"submit\">submit</label></dt>
	<dd class=\"submit\"><input type=\"submit\" name=\"submit\" id=\"submit\" value=\"submit\" /></dd>
</dl>
<p class=\"note\">JUGEMǥݡȤƤSimple XMLΥϤMovable TypeʤɤѤǤƥȥեޥåȤѴޤץ졼ƥȤξ֤ǽϤΤǡ̾¸פʤɤѤơȤΥѥˡ.txtפȤĥҤ¸ƤѴˤϻ֤礬ޤ</p>
<p class=\"link\">[<a href=\"mtlog2xml.cgi\">mtlog2xml</a>]</p>
</form>
<address>Copyright \&copy; SimpleBoxes 2004. All rights reserved. \[ver. $gVersion_\]</address>
<address>Provided by <a href=\"http://paperboy.co.jp\" target=\"_blank\">paperboy\&amp;co.</a></address>
</body>
</html>
_HTML_
	return();
}
sub main {
	my ($uri,$xml) = @_;
	eval {
		if ($xml eq '' and $uri ne '') {
			$uri = &sbtxt_uridec($uri);
			if ($uri =~ /jugem\.cc\/?$/ and $uri =~ /^http:\/\//) {
				chop($uri) if ($uri =~ /\/$/);
				$uri .= '/?mode=xml';
				require LWP::UserAgent;
				my $ua = LWP::UserAgent->new;
				my $response = $ua->get($uri);
				if ( ${$response}{'_rc'} eq '200' and ${$response}{'_msg'} =~ /ok/i ) {
					$xml = ${$response}{'_content'};
				} else {
					die('error during connection');
				}
			} else {
				die($uri . ' is not Jugem site.');
			}
		} elsif ($xml eq '') {
			die('&quot;uri&quot; or &quot;xml file&quot; is required.');
		}
	};
	&error($@) if ($@);
	print 'Content-type: text/plain',"\n\n"; # http head
	eval {
		$xml = &remove_cdata($xml);
		use XML::Parser::Lite;
		my $parser = new XML::Parser::Lite;
		$parser->setHandlers(
			Init  => \&sbjgm_logInit,
			Final => \&sbjgm_logFinal,
			Start => \&sbjgm_logStart,
			Char  => \&sbjgm_logChar,
			End   => \&sbjgm_logEnd,
		);
		$parser->parse($xml);
	};
	print 'error : ',$@ if ($@);
}
sub error {
	my $text = shift;
	print 'Content-type: text/html;charset=EUC-JP',"\n\n"; # http head
	print <<"_HTML_";
<?xml version=\"1.0\" encoding=\"EUC-JP\"?>
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\" lang=\"ja\">
<head>
	<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\" />
	<title>error</title>
</head>
<body>
<h1>error</h1>
<p>$text</p>
</body>
</html>
_HTML_
	exit(0);
}
sub remove_cdata {
	my $text = shift;
	my $output = '';
	my $tail = $2 if ( $text =~ /(.*)\]\]\>(.*)/s );
	while ( $text =~ s/(.*?)<\!\[CDATA\[(.*?)\]\]\>//s ) {
		$output .= $1 . '&sbx;' . &sbtxt_ent($2);
	}
	$output .= $tail;
	return($output);
}
sub sbjgm_logPrintElem {
	my ($type,$key,$value) = @_;
	my ($pre,$post) = ();
	if ($key eq 'category' and $type eq 'entry') {
		$value = &sbjgm_logCatConv($value);
		$pre = 'PRIMARY CATEGORY: ';
		$post = "\n";
		$gBuf = $value;
	} elsif ($key eq 'add_category' and $type eq 'entry') {
		$value = &sbjgm_logCatConv($value);
		$pre = 'CATEGORY: ';
		$post = "\n\n";
		$value = $gBuf if ($value eq '');
	} elsif ($key eq 'allowcomments' and $type eq 'entry') {
		$pre = 'ALLOW COMMENTS: ';
		$post = "\n";
		$value = 1 if ($value eq '');
	} elsif ($key eq 'convertbreaks' and $type eq 'entry') {
		$pre = 'CONVERT BREAKS: ';
		$post = "\n";
		$value = 0 if ($value eq '');
	} elsif ($key eq 'status' and $type eq 'entry') {
		$pre = uc($key) . ': ';
		$post = "\n";
		$value = 'Publish' if ($value eq '');
	} elsif ($key eq 'allowpings' and $type eq 'entry') {
		$pre = 'ALLOW PINGS: ';
		$post = "\n";
		$value = 1 if ($value eq '');
	} elsif ($key eq 'description' and $type eq 'entry') {
		$pre = "BODY:\n";
		$post = "\n-----\n";
	} elsif ($key eq 'sequel' and $type eq 'entry') {
		$pre = "EXTENDED BODY:\n";
		$post = "\n-----\n";
	} elsif ($key eq 'excerpt' and $type eq 'entry') {
		$pre = "EXCERPT:\n";
		$post = "\n-----\n";
	} elsif ($key eq 'keyword' and $type eq 'entry') {
		$pre = "KEYWORDS:\n";
		$post = "\n";
	} elsif ($key eq 'name' and $type eq 'comments') {
		$pre = 'AUTHOR: ';
		$post = "\n";
	} elsif ($key eq 'description' and $type eq 'comments') {
		$pre = '';
		$post = "\n";
	} elsif ($key eq 'excerpt' and $type eq 'trackbacks') {
		$pre = '';
		$post = "\n";
	} elsif ($key eq 'blog_name' and $type eq 'trackbacks') {
		$pre = 'BLOG NAME: ';
		$post = "\n";
	} elsif ($key eq 'host') {
		$pre = 'IP: ';
		$post = "\n";
	} elsif ($key eq 'date') {
		$value = &sbjgm_logDateConv($value);
		$pre = uc($key) . ': ';
		$post = ($type eq 'entry') ? "\n-----\n" : "\n";
	} else {
		$pre = uc($key) . ': ';
		$post = "\n";
	}
	return($pre . $value . $post);
}
sub sbjgm_logPrintParts {
	my ($id,$type,$num) = @_;
	my $out = '';
	my @elem = ();
	@elem = ('author','title','status','allowcomments','convertbreaks','allowpings','category','add_category','date','description','sequel','excerpt','keyword') if ($type eq 'entry');
	@elem = ('name','email','host','url','date','description') if ($type eq 'comments');
	@elem = ('title','url','host','blog_name','excerpt') if ($type eq 'trackbacks');
	for (my $i=0;$i<=$num;$i++) {
		$out .= 'COMMENT:' . "\n" if ($type eq 'comments');
		$out .= 'PING:' . "\n" if ($type eq 'trackbacks');
		foreach my $key (@elem) {
			my $value = $sbLog->{'buf'}->{$id}->{$type}->{$i}->{$key};
			if ($value =~ /^&sbx;/) {
				$value =~ s/^&sbx;//;
				$value = &sbtxt_det($value);
			}
			$out .= &sbjgm_logPrintElem($type,$key,$value);
		}
		$out .= '-----' . "\n";
	}
	return($out);
}
sub sbjgm_logPrint {
	my $id = shift;
	my $out = '';
	$out .= &sbjgm_logPrintParts($id,'entry',0);
	$out .= &sbjgm_logPrintParts($id,'comments',$sbLog->{'buf'}->{$id}->{'cnum'}) if ($sbLog->{'buf'}->{$id}->{'cnum'} > -1);
	$out .= &sbjgm_logPrintParts($id,'trackbacks',$sbLog->{'buf'}->{$id}->{'tnum'}) if ($sbLog->{'buf'}->{$id}->{'tnum'} > -1);
	$out .= "\n" . '--------' . "\n";
	return($out);
}
sub sbjgm_logDateConv {
	my $text = shift;
	if ($text =~ /(\d\d\d\d)\/(\d\d)\/(\d\d) (\d\d)\:(\d\d\:\d\d)/) {
		my $ho = $4;
		my $mm = 'AM';
		if ($ho > 11) {
			$mm = 'PM';
			$ho -= 12;
		}
		return($2 . '/' . $3 . '/' . $1 . ' ' . $ho . ':' . $5 . ' ' . $mm);
	}
	return($text);
}
sub sbjgm_logCatConv {
	my $text = shift;
	$text = (split('##',$text,2))[1] if (index($text,'##') > -1);
	return($text);
}
sub sbjgm_logInit {
	my $self = shift;
	$sbLog->{'tagname'} = '';
	$sbLog->{'flag'} = 0;
	$sbLog->{'stat'} = '';
	$sbLog->{'buf'} = {};
	$sbLog->{'eid'} = -1;
}
sub sbjgm_logFinal {
	my $self = shift;
	my $out = '';
	for (my $i=0;$i<=$sbLog->{'eid'};$i++) {
		$out .= &sbjgm_logPrint($i);
	}
	&$gEncode(\$out,$gIn{'code'},'utf8') if ($gIn{'code'} ne 'utf8' and $gIn{'code'});
	print $out;
}
sub sbjgm_logStart {
	my $self = shift;
	my $name = shift;
	$sbLog->{'tagname'} = $name;
	if ($sbLog->{'tagname'} eq 'entries') {
		$sbLog->{'flag'} = 1;
	} elsif ($sbLog->{'tagname'} eq 'entry') {
		if ($sbLog->{'flag'}) {
			$sbLog->{'eid'}++;
			$sbLog->{'stat'} = $sbLog->{'tagname'};
			$sbLog->{'buf'}->{$sbLog->{'eid'}} = {};
			$sbLog->{'buf'}->{$sbLog->{'eid'}}->{'cnum'} = -1;
			$sbLog->{'buf'}->{$sbLog->{'eid'}}->{'tnum'} = -1;
		}
	} elsif ($sbLog->{'tagname'} eq 'comments') {
		$sbLog->{'stat'} = $sbLog->{'tagname'} if ($sbLog->{'flag'} and $sbLog->{'eid'} > -1);
	} elsif ($sbLog->{'tagname'} eq 'comment') {
		$sbLog->{'buf'}->{$sbLog->{'eid'}}->{'cnum'}++ if ($sbLog->{'stat'} eq 'comments');
	} elsif ($sbLog->{'tagname'} eq 'trackbacks') {
		$sbLog->{'stat'} = $sbLog->{'tagname'} if ($sbLog->{'flag'} and $sbLog->{'eid'} > -1);
	} elsif ($sbLog->{'tagname'} eq 'trackback') {
		$sbLog->{'buf'}->{$sbLog->{'eid'}}->{'tnum'}++ if ($sbLog->{'stat'} eq 'trackbacks');
	}
}
sub sbjgm_logChar {
	my $self = shift;
	my $name = shift;
	if ($sbLog->{'flag'}) {
		my $num  = 0;
		my $stat = $sbLog->{'stat'};
		my $eid  = $sbLog->{'eid'};
		$num = ($stat eq 'comments') ? $sbLog->{'buf'}->{$eid}->{'cnum'} : $sbLog->{'buf'}->{$eid}->{'tnum'} if ($stat ne 'entry');
		$sbLog->{'buf'}->{$eid}->{$stat}->{$num}->{$sbLog->{'tagname'}} = $name;
	}
}
sub sbjgm_logEnd {
	my $self = shift;
	my $name = shift;
	if ($name eq 'entries') {
		$sbLog->{'flag'} = 0;
	} elsif ($name eq 'entry') {
	} elsif ($name eq 'comments') {
	} elsif ($name eq 'comment') {
	} elsif ($name eq 'trackbacks') {
	} elsif ($name eq 'trackback') {
	}
}
